module ScoreBoard (CLK, RESET, OUT) ;
input CLK;
input RESET;
reg [3:0] PLACE1, PLACE2, PLACE3, PLACE4, PLACE5, PLACE6, PLACE7;
reg [25:0] spacer;
output [27:0] OUT;

assign OUT[3:0] = PLACE1[3:0];
assign OUT[7:4] = PLACE2[3:0];
assign OUT[11:8] = PLACE3[3:0];
assign OUT[15:12] = PLACE4[3:0];
assign OUT[19:16] = PLACE5[3:0];
assign OUT[23:20] = PLACE6[3:0];
assign OUT[27:24] = PLACE7[3:0];

always @(posedge CLK) begin
	if(RESET) begin
		spacer <= 1;
		PLACE1 <= 0;
		PLACE2 <= 0;
		PLACE3 <= 0;
		PLACE4 <= 0;
		PLACE5 <= 0;
		PLACE6 <= 0;
		PLACE7 <= 0;
	end
	else begin
		spacer <= spacer + 1;
		if(PLACE1 == 9 && spacer == 0) begin
			PLACE1 <= 0;
		end
		else begin
			if(spacer == 0) begin
				PLACE1 <= PLACE1 + 1;
			end
		end
		if(PLACE1 == 9 && spacer == 0) begin
			if(PLACE2 == 9) begin
				PLACE2 <= 0;
			end
			else begin
				PLACE2 <= PLACE2 + 1;
			end
		end
		if(PLACE1 == 9 && PLACE2 == 9 && spacer == 0) begin
			if(PLACE3 == 9) begin
				PLACE3 <= 0;
			end
			else begin
				PLACE3 <= PLACE3 + 1;
			end
		end
		if(PLACE1 == 9 && PLACE2 == 9 && PLACE3 == 9 && spacer == 0) begin
			if(PLACE4 == 9) begin
				PLACE4 <= 0;
			end
			else begin
				PLACE4 <= PLACE4 + 1;
			end
		end
		if(PLACE1 == 9 && PLACE2 == 9 && PLACE3 == 9 && PLACE4 == 9 && spacer == 0) begin
			if(PLACE5 == 9) begin
				PLACE5 <= 0;
			end
			else begin
				PLACE5 <= PLACE5 + 1;
			end
		end
		if(PLACE1 == 9 && PLACE2 == 9 && PLACE3 == 9 && PLACE4 == 9 && PLACE5 == 9 && spacer == 0) begin
			if(PLACE6 == 9) begin
				PLACE6 <= 0;
			end
			else begin
				PLACE6 <= PLACE6 + 1;
			end
		end
		if(PLACE1 == 9 && PLACE2 == 9 && PLACE3 == 9 && PLACE4 == 9 && PLACE5 == 9 && PLACE6 == 9 && spacer == 0) begin
			if(PLACE7 == 9) begin
				PLACE7 <= 0;
			end
			else begin
				PLACE7 <= PLACE7 + 1;
			end
		end
	end
end
		


endmodule 
