module SYNCH (CLK, OTHER_CLK, IN, NEW_KEY) ;
input CLK, OTHER_CLK, IN;
output NEW_KEY;
reg NEW_KEY;
reg TEMP;
reg COUNTER;

always @(posedge CLK) begin
	if(IN == 1) begin
		TEMP = IN;
		COUNTER <= 0;
		NEW_KEY <= 0;
	end
	else begin
	if(TEMP == 1 && OTHER_CLK == 1) begin
		if(COUNTER == 1) begin
			NEW_KEY <= 0;
			COUNTER <= 0;
			TEMP = 0;
		end
		else begin
			NEW_KEY <= 1;
			COUNTER <= 1;
		end
	end
	else begin
		NEW_KEY <= 0;
	end
	end
end

endmodule 
