------------------------------------------------------
-- LogiBLOX SYNC_RAM Module "testrom"
-- Created by LogiBLOX version D.24
--    on Thu Mar 01 14:23:19 2001
-- Attributes 
--    MODTYPE = SYNC_RAM
--    BUS_WIDTH = 4
--    DEPTH = 80
--    MEMFILE = row1
--    STYLE = MAX_SPEED
--    USE_RPM = FALSE
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY testrom IS
  PORT(
    A: IN std_logic_vector(6 DOWNTO 0);
    DO: OUT std_logic_vector(3 DOWNTO 0);
    DI: IN std_logic_vector(3 DOWNTO 0);
    WR_EN: IN std_logic;
    WR_CLK: IN std_logic);
END testrom;

-- synopsys translate_off
ARCHITECTURE sim OF testrom IS
  SIGNAL START_PULSE: std_logic := '1';
  TYPE mem_data IS ARRAY (79 DOWNTO 0) OF std_logic_vector(3 DOWNTO 0);
BEGIN
  PROCESS
  VARIABLE VD: mem_data;
  VARIABLE first_time: BOOLEAN := TRUE;
  BEGIN
    IF (first_time) THEN
      VD(0) := ('0','1','0','0');
      VD(1) := ('0','1','0','0');
      VD(2) := ('0','1','0','0');
      VD(3) := ('0','1','0','0');
      VD(4) := ('0','1','0','0');
      VD(5) := ('0','1','0','0');
      VD(6) := ('0','1','0','0');
      VD(7) := ('0','1','0','0');
      VD(8) := ('0','1','0','0');
      VD(9) := ('0','0','0','0');
      VD(10) := ('0','0','0','0');
      VD(11) := ('0','0','0','0');
      VD(12) := ('0','0','0','0');
      VD(13) := ('0','0','0','0');
      VD(14) := ('0','0','0','0');
      VD(15) := ('0','0','0','0');
      VD(16) := ('0','0','0','0');
      VD(17) := ('0','0','0','0');
      VD(18) := ('0','0','0','0');
      VD(19) := ('0','0','0','0');
      VD(20) := ('0','0','0','0');
      VD(21) := ('0','0','0','0');
      VD(22) := ('0','0','0','0');
      VD(23) := ('0','0','0','0');
      VD(24) := ('0','0','0','0');
      VD(25) := ('0','0','0','0');
      VD(26) := ('0','0','0','0');
      VD(27) := ('0','0','0','0');
      VD(28) := ('0','0','0','0');
      VD(29) := ('0','0','0','0');
      VD(30) := ('0','0','0','0');
      VD(31) := ('0','0','0','0');
      VD(32) := ('0','0','0','0');
      VD(33) := ('0','0','0','0');
      VD(34) := ('0','0','0','0');
      VD(35) := ('0','0','0','0');
      VD(36) := ('0','0','0','0');
      VD(37) := ('0','0','0','0');
      VD(38) := ('0','0','0','0');
      VD(39) := ('0','0','0','0');
      VD(40) := ('0','0','0','0');
      VD(41) := ('0','0','0','0');
      VD(42) := ('0','0','0','0');
      VD(43) := ('0','0','0','0');
      VD(44) := ('0','0','0','0');
      VD(45) := ('0','0','0','0');
      VD(46) := ('0','0','0','0');
      VD(47) := ('0','0','0','0');
      VD(48) := ('0','0','0','0');
      VD(49) := ('0','0','0','0');
      VD(50) := ('0','0','0','0');
      VD(51) := ('0','0','0','0');
      VD(52) := ('0','0','0','0');
      VD(53) := ('0','0','0','0');
      VD(54) := ('0','0','0','0');
      VD(55) := ('0','0','0','0');
      VD(56) := ('0','0','0','0');
      VD(57) := ('0','0','0','0');
      VD(58) := ('0','0','0','0');
      VD(59) := ('0','0','0','0');
      VD(60) := ('0','0','0','0');
      VD(61) := ('0','0','0','0');
      VD(62) := ('0','0','0','0');
      VD(63) := ('0','0','0','0');
      VD(64) := ('0','0','0','0');
      VD(65) := ('0','0','0','0');
      VD(66) := ('0','0','0','0');
      VD(67) := ('0','0','0','0');
      VD(68) := ('0','0','0','0');
      VD(69) := ('0','0','0','0');
      VD(70) := ('0','0','0','0');
      VD(71) := ('0','0','0','0');
      VD(72) := ('0','0','0','0');
      VD(73) := ('0','0','0','0');
      VD(74) := ('0','0','0','0');
      VD(75) := ('0','0','0','0');
      VD(76) := ('0','0','0','0');
      VD(77) := ('0','0','0','0');
      VD(78) := ('0','0','0','0');
      VD(79) := ('0','0','0','0');
      first_time := FALSE;
    END IF;
    IF (WR_CLK'EVENT AND stdbit2mvl(WR_CLK)='1' AND stdbit2mvl(WR_CLK'LAST_VALUE)='0')
    AND (WR_EN='1') AND (NOT mvlvec_not01(A)) AND (mvlvec2int(A) < 80) THEN
      VD(mvlvec2int(A)) := stdvec2mvl(DI);
    END IF;
    IF (mvlvec_not01(A) OR
       (stdbit2mvl(WR_CLK) = 'X')
       OR (WR_CLK'EVENT AND stdbit2mvl(WR_CLK)='1' AND stdbit2mvl(WR_CLK'LAST_VALUE)='0'
           AND stdbit2mvl(WR_EN) = 'X' )
      ) THEN
        DO <= ('X','X','X','X');
    ELSIF (mvlvec2int(A) > 79) THEN
      ASSERT (FALSE)
      REPORT "The value on the address line is out of range"
      SEVERITY WARNING;
      DO <= ('X','X','X','X');
    ELSE
      DO <= VD(mvlvec2int(A));
    END IF;
      WAIT ON A, DI, WR_EN, WR_CLK, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
